Index: /applications/dual/IterativeLocal/text/bpkomplet.lyx
===================================================================
--- /applications/dual/IterativeLocal/text/bpkomplet.lyx (revision 1104)
+++ /applications/dual/IterativeLocal/text/bpkomplet.lyx (revision 1110)
@@ -6526,5 +6526,5 @@
 
 .
- Dále je provedena simulace běhu systému s použítím řízení získaného v předchozí
+ Dále je provedena simulace běhu systému s použitím řízení získaného v předchozí
 m kroku.
  V průběhu této simulace je vypočítána hodnota dosažené ztráty a posloupnost
@@ -6535,9 +6535,9 @@
 
 \begin_layout Subsection
-Testovací shémata jednoduchého systému
-\end_layout
-
-\begin_layout Standard
-Pro porovnání jednotlivých algortimů stačí zadat do skriptu konkrétní hodnoty
+Testovací schémata jednoduchého systému
+\end_layout
+
+\begin_layout Standard
+Pro porovnání jednotlivých algoritmů stačí zadat do skriptu konkrétní hodnoty
  parametrů, které budou pro jednotlivá schémata uvedena dále.
 \end_layout
@@ -6612,5 +6612,5 @@
 
 \begin_layout Standard
-Volba počáteční nastavení, tedy parametrů skriptu pro volání funkcí byla
+Volba počátečních nastavení, tedy parametrů skriptu pro volání funkcí, byla
  v jednotlivých testovacích schématech následující: 
 \end_layout
@@ -6700,5 +6700,5 @@
 \end_inset
 
- a právě tam neduální metody dosáhnou příliš velké ztráty, nebo úplně selžou
+, a právě tam neduální metody dosáhnou příliš velké ztráty, nebo úplně selžou
  v úkolu řízení.
  Z tohoto důvodu byly testovány všechny kombinace pro volby parametrů
@@ -6717,5 +6717,5 @@
 
 \begin_layout Standard
-Nyní porovnáme výsledky jednotlivých algoritmů a to hlavně podle dosažené
+Nyní porovnáme výsledky jednotlivých algoritmů, a to hlavně podle dosažené
  hodnoty průměrné ztráty.
  Průměrná ztráta pro každý algoritmus je počítáma jako aritmetický průměr
@@ -6744,5 +6744,5 @@
 
  pro daný algoritmus.
- Pro srovnání, je minimální ztráta, které algoritmus může dosáhnout rovna
+ Pro srovnání je minimální ztráta, které algoritmus může dosáhnout, rovna
  
 \begin_inset Formula $1$
@@ -6763,5 +6763,5 @@
 \end_inset
 
- a tedy vždy bude ztráta nejméně 
+, a tedy vždy bude ztráta nejméně 
 \begin_inset Formula $1$
 \end_inset
@@ -6770,5 +6770,5 @@
  Dále je třeba uvažovat chybu v důsledku šumu, který se generuje náhodně.
  Řízení se s ním ale vypořádává až následně, tedy nelze chybě v důsledku
- šumu předcházet a je ji nutno zahrnout do úvažování o minimální možné ztrátě.
+ šumu předcházet a je ji nutno zahrnout do uvažování o minimální možné ztrátě.
  Naopak, pro srovnání, když uvažujeme nulové řízení na celém časovém horizontu,
  hodnota 
@@ -6782,5 +6782,5 @@
 \end_inset
 
- zůstává konstantně na nule i když se chceme dostat na 
+ zůstává konstantně na nule, i když se chceme dostat na 
 \begin_inset Formula $y_{r}=1$
 \end_inset
@@ -6933,5 +6933,5 @@
 sLQ
 \emph default
- jehož řešení a následně i ztráta jsou nedefinovány (
+, jehož řešení a následně i ztráta jsou nedefinovány (
 \begin_inset Quotes gld
 \end_inset
@@ -6971,5 +6971,5 @@
 
 .
- Částečně tento problém řeší přídání pomocného parametru 
+ Částečně tento problém řeší přidání pomocného parametru 
 \begin_inset Formula $\varepsilon$
 \end_inset
@@ -7009,5 +7009,5 @@
 \end_inset
 
- pro vyšší hodnutu variance 
+ pro vyšší hodnotu variance 
 \begin_inset Formula $P=0,1$
 \end_inset
@@ -7113,9 +7113,9 @@
 \end_inset
 
- a tedy značně narůstá pravděpodobnost konkrétní realizace parametru 
+, a tedy značně narůstá pravděpodobnost konkrétní realizace parametru 
 \begin_inset Formula $b$
 \end_inset
 
- jehož skutečná hodnota bude velmi blízko nuly.
+, jehož skutečná hodnota bude velmi blízko nuly.
  Právě to se nejvýrazněji projevuje u algoritmů 
 \emph on
@@ -7539,10 +7539,10 @@
 \emph default
  jako nepoužitelné.
- Dále se jedná o neduální metodu a tedy při velké varianci a tedy neznalosti
+ Dále se jedná o neduální metodu; při velké varianci, a tedy neznalosti
  o skutečné hodnotě parametru 
 \begin_inset Formula $b$
 \end_inset
 
- dosahujeme velké ztráty.
+, dosahujeme velké ztráty.
 \end_layout
 
@@ -8032,7 +8032,7 @@
 \emph default
  se jeví jako nejlepší ze zde testovaných algoritmů.
- A to ve srovnání s ostatnímí, ale i jak je patrno z tabulky průměrných
+ A to ve srovnání s ostatními, ale i jak je patrno z tabulky průměrných
  ztrát.
- Dosažená hodnota průměrné ztráty je velmi nízká a to pro všechny případy
+ Dosažená hodnota průměrné ztráty je velmi nízká, a to pro všechny případy
  volby parametrů 
 \begin_inset Formula $\hat{b}$
@@ -8045,5 +8045,5 @@
 .
  Uvažujeme samozřejmě verzi LQ řízení pro upravený systém, kdy je zahrnut
- do stavových proměných i odhad skutečného parametru 
+ do stavových proměnných i odhad skutečného parametru 
 \begin_inset Formula $b$
 \end_inset
@@ -8073,5 +8073,5 @@
 LQ 
 \emph default
-je však narozdíl od složitějších algoritmů, řešen pouze linearizací v každém
+je však na rozdíl od složitějších algoritmů řešen pouze linearizací v každém
  časovém kroku, ale bez aproximací a numerických výpočtů.
 \end_layout
@@ -8353,5 +8353,5 @@
 iLQG
 \emph default
- za duální algortimus.
+ za duální algoritmus.
 \end_layout
 
@@ -8585,5 +8585,5 @@
  blízko nuly.
  V tabulce průměrných ztrát můžeme vypozorovat, že ztráta je příliš vysoká
- právě v případě kdy je střední hodnota 
+ právě v případě, kdy je střední hodnota 
 \begin_inset Formula $\hat{b}=0$
 \end_inset
@@ -8752,5 +8752,5 @@
 
 .
- Šum způsobuje, že každá z generovaných trajektorií má trochu jiný průběh
+ Šum způsobuje, že každá z generovaných trajektorií má trochu jiný průběh,
  a tedy všechny nesplývají v jednu, ale tvoří jakousi 
 \begin_inset Quotes gld
@@ -8823,5 +8823,5 @@
  a naopak kolem ní osciluje.
  Při volbě ještě větších variancí pak narůstá četnost trajektorií, které
- místo příblížení požadované hodnotě dokonce divergují.
+ místo přiblížení požadované hodnotě dokonce divergují.
  
 \begin_inset Float figure
@@ -9158,5 +9158,5 @@
 \emph default
  řízení, kdy docházelo k oscilacím a divergujícím trajektoriím, v tomto
- případě, dochází spíše k odchýlení trajektorie od požadovaného průběhu.
+ případě dochází spíše k odchýlení trajektorie od požadovaného průběhu.
  První dvě řízení totiž nejsou duální a užíváme principu 
 \begin_inset Quotes gld
@@ -9265,5 +9265,5 @@
 \end_inset
 
- algroritmus vůbec nedokončí výpočet.
+ algoritmus vůbec nedokončí výpočet.
  
 \end_layout
@@ -9313,5 +9313,5 @@
 
  uvedeny příslušné rovnice.
- Následně byly odvozeny detaily konkrétních implementace pro použité algoritmy.
+ Následně byly odvozeny detaily konkrétní implementace pro použité algoritmy.
  Pro získání výsledků a ověření použitelnosti řízení je však ještě třeba
  specifikovat konkrétní hodnoty jednotlivých konstant a parametrů.
@@ -9363,5 +9363,5 @@
 \end_inset
 
- předpokládámé známe a pro účely testování je volíme následovně:
+ předpokládáme známé a pro účely testování je volíme následovně:
 \begin_inset Formula \begin{eqnarray*}
 M_{k} & = & \mathrm{diag\left(0,0013;\:0,0013;\:5e-6;\:1e-10\right),}\\
@@ -9400,5 +9400,5 @@
 
 \begin_layout Standard
-Do ztrátové funkce je třeba zvolit jediný parametr a to prvek 
+Do ztrátové funkce je třeba zvolit jediný parametr, a to prvek 
 \begin_inset Formula $r$
 \end_inset
@@ -9477,5 +9477,5 @@
  Nemůžeme totiž měřit stav, zejména polohu a otáčky hřídele.
  Abychom mohli testovat chování algoritmu při rostoucí potřebě duálního
- přístupu, podobně jako pro jednoduchý systém, budeme volit stejné střední
+ přístupu, podobně jako pro jednoduchý systém budeme volit stejné střední
  hodnoty, ale postupně rostoucí varianci.
  To se bude týkat variance polohy hřídele, to jest úhlu natočení.
@@ -9698,5 +9698,5 @@
 LQG
 \emph default
- neduální, s rostoucí variancí poskytuje špatné řízení a to zpravidla v
+ neduální, s rostoucí variancí poskytuje špatné řízení, a to zpravidla v
  těch případech, kdy skutečné hodnoty polohy hřídele 
 \begin_inset Formula $\vartheta$
@@ -9704,5 +9704,5 @@
 
  jsou vzdáleny střední hodnotě, se kterou počítáme.
- Jednotlivé průběhy jsou zachyceny v grafech: Obrázek 
+ Jednotlivé průběhy jsou zachyceny v grafech Obrázek 
 \begin_inset CommandInset ref
 LatexCommand ref
@@ -9711,39 +9711,18 @@
 \end_inset
 
- pro volbu variance 
+ pro volby variance 
 \begin_inset Formula $P_{\vartheta}=0,01$
 \end_inset
 
-, Obrázek 
-\begin_inset CommandInset ref
-LatexCommand ref
-reference "Flo:prubehy-pmsm"
-
-\end_inset
-
- pro 
+, 
 \begin_inset Formula $P_{\vartheta}=0,1$
 \end_inset
 
-, pro 
+, 
 \begin_inset Formula $P_{\vartheta}=1$
 \end_inset
 
- pak Obrázek 
-\begin_inset CommandInset ref
-LatexCommand ref
-reference "Flo:prubehy-pmsm"
-
-\end_inset
-
- a nazávěr pro 
+ a 
 \begin_inset Formula $P_{\vartheta}=10$
-\end_inset
-
- je Obrázek 
-\begin_inset CommandInset ref
-LatexCommand ref
-reference "Flo:prubehy-pmsm"
-
 \end_inset
 
@@ -9753,5 +9732,5 @@
 wide false
 sideways false
-status collapsed
+status open
 
 \begin_layout Plain Layout
@@ -9924,9 +9903,9 @@
 
 \begin_layout Standard
-Nyní srovnáme dosažené výsledky pro jednotlivé algortimy a budeme diskutovat
- jejich přednosti, nedostatky a použitelnost na řešení konkrétních úloh.
+Nyní srovnáme dosažené výsledky pro jednotlivé algoritmy a budeme diskutovat
+ jejich přednosti, nedostatky a použitelnost pro řešení konkrétních úloh.
  Pro úlohu nalezení řízení synchronního motoru s permanentními magnety byly
  implementovány dva algoritmy.
- Konkrétně se jednolo o algoritmy 
+ Konkrétně se jednalo o algoritmy 
 \emph on
 iLDP
@@ -9941,7 +9920,7 @@
 \emph default
  se nepodařilo vytvořit.
- K dispozici je pro tuto úlohu pouze jeden algoritmus, který nalezne řízení
+ K dispozici je pro tuto úlohu pouze jeden algoritmus, který nalezne řízení,
  a srovnání tedy není možné.
- Z tohoto důvodu budou tedy jendotlivé algoritmy srovnány pouze na základě
+ Z tohoto důvodu budou tedy jednotlivé algoritmy srovnány pouze na základě
  výsledků pro jednoduchý systém.
  Algoritmus 
@@ -9960,5 +9939,5 @@
  Jedná se o integrátor s neznámým ziskem, tedy lineární a časově invariantní
  systém.
- Jde však o systém na mezi stability, což může být příčinou problémů některých
+ Systém je však na mezi stability, což může být příčinou problémů některých
  algoritmů.
  Další problém může nastat, když by hodnota neznámého parametru 
@@ -9986,5 +9965,5 @@
 \end_inset
 
- považujeme za náhodnou veličinu s normálním rozdělením a tedy neuvažujeme-li
+ považujeme za náhodnou veličinu s normálním rozdělením, a tedy neuvažujeme-li
  degenerované rozdělení, je pravděpodobnost dosažení přesné hodnoty 
 \begin_inset Formula $b=0$
@@ -9996,5 +9975,5 @@
 \end_inset
 
- za známou například použítím principu 
+ za známou například použitím principu 
 \begin_inset Quotes gld
 \end_inset
@@ -10023,5 +10002,5 @@
 \end_inset
 
- známe a tedy ji pokládáme rovnu jeho střední hodnotě 
+ známe, a tedy ji pokládáme rovnu jeho střední hodnotě 
 \begin_inset Formula $\mathrm{E}b$
 \end_inset
@@ -10034,5 +10013,5 @@
  příliš vzdálená od střední hodnoty, se kterou počítáme, řízení samozřejmě
  selhává.
- Tento přístup tedy není duální a jak bylo možno pozorovat na výsledcích
+ Tento přístup tedy není duální, a jak bylo možno pozorovat na výsledcích
  simulací, s rostoucí variancí 
 \begin_inset Formula $P$
@@ -10052,5 +10031,5 @@
 \end_inset
 
-, kdy zřejmě, z tvaru rovnice regulátoru hrozí dělení nulou.
+, kdy zřejmě z tvaru rovnice regulátoru hrozí dělení nulou.
  Přičtením malého parametru 
 \begin_inset Formula $\varepsilon$
@@ -10084,5 +10063,5 @@
 
 , což ale velmi snižuje univerzálnost metody.
- Dalším možným způsobem je, místo malého parametu 
+ Dalším možným způsobem je místo malého parametu 
 \begin_inset Formula $\varepsilon$
 \end_inset
@@ -10123,5 +10102,5 @@
 CE
 \emph default
- tedy můžeme stručně zhodnotit tak, že je sice velmi jednoduchý, ale neduální
+ tedy můžeme stručně zhodnotit tak, že je sice velmi jednoduchý, ale neduální,
  a vykazuje značně problematické chování pro střední hodnotu 
 \begin_inset Formula $\mathrm{E}b=0$
@@ -10140,5 +10119,5 @@
 sLQ
 \emph default
- bylo použito pro klasické LQ řízení aplikováno na základní verzi jednoduchého
+ bylo použito pro klasické LQ řízení aplikované na základní verzi jednoduchého
  systému bez dodatečných úprav.
  Protože je ale skutečná hodnota parametru 
@@ -10151,5 +10130,5 @@
 \end_inset
 
-ceratinty equivalence
+certainty equivalence
 \begin_inset Quotes grd
 \end_inset
@@ -10177,5 +10156,5 @@
 
 \begin_layout Standard
-Již z tvaru rovnice základní verze jednoduchého systému je zřejmě, že předpoklád
+Již z tvaru rovnice základní verze jednoduchého systému je zřejmé, že předpoklád
 áme-li parametr 
 \begin_inset Formula $b$
@@ -10199,5 +10178,5 @@
 
 \begin_layout Standard
-Je třeba uvést, že se nejedná o duální metodu a tedy s rostoucí variancí
+Je třeba uvést, že se nejedná o duální metodu, a tedy s rostoucí variancí
  neznámého parametru dosahujeme vyšší ztráty.
  Dosažené výsledky jsou pak podobné jako u 
@@ -10251,5 +10230,5 @@
 
 \begin_layout Standard
-Narozdíl od složitějších algoritmů, nevyužívá 
+Na rozdíl od složitějších algoritmů nevyužívá 
 \emph on
 LQ
@@ -10303,5 +10282,5 @@
 \emph default
  je nejprve linearizace a pak vyjádření vztahů pomocí matic, které mohou
- být ještě dále upravovány z důvodu, například omezení vstupů nebo zajištění
+ být ještě dále upravovány z důvodu například omezení vstupů nebo zajištění
  regularity.
  Dále je třeba zmínit, že se v podstatě jedná o lokální metodu, protože
@@ -10338,5 +10317,9 @@
 \end_inset
 
-, a 
+ a libovolného 
+\begin_inset Formula $P$
+\end_inset
+
+, nebo 
 \begin_inset Formula $\hat{b}=1$
 \end_inset
@@ -10346,6 +10329,6 @@
 \end_inset
 
- nebo 
-\begin_inset Formula $P=0.1$
+ popřípadě 
+\begin_inset Formula $P=0,1$
 \end_inset
 
@@ -10355,5 +10338,5 @@
 \end_inset
 
- nebo 
+, nebo 
 \begin_inset Formula $\hat{b}=1$
 \end_inset
@@ -10390,7 +10373,7 @@
  v okolí nuly.
  Výpočet řízení je totiž při použití tohoto algoritmu značně závislý na
- volbě reprezentativní trajektorie, kterou, když vygenerujeme špatně, dostaneme
+ volbě reprezentativní trajektorie, kterou když vygenerujeme špatně, dostaneme
  i špatné řízení.
- Právě v blízkosti nuly může dochjít k nepříznivému generování reprezentativní
+ Právě v blízkosti nuly může dojít k nepříznivému generování reprezentativní
  trajektorie.
  Vycházíme z 
@@ -10398,9 +10381,9 @@
 \end_inset
 
- a tedy, při kladném parametru 
+, a tedy při kladném parametru 
 \begin_inset Formula $b$
 \end_inset
 
-, generujeme trajektorii do kladných hodnot, nebo se naopak dostáváme do
+ generujeme trajektorii do kladných hodnot, nebo se naopak dostáváme do
  záporných čísel, je-li skutečná hodnota parametru 
 \begin_inset Formula $b$
@@ -10408,6 +10391,6 @@
 
  záporná.
- Tento rozpor pak může způsobit problémy, jako špatné řízení a dosažení
- vyšší ztráty.
+ Tento rozpor pak může způsobit problémy jako špatné řízení a dosažení vyšší
+ ztráty.
 \end_layout
 
@@ -10417,5 +10400,5 @@
 
 \begin_layout Standard
-Algoritmu 
+Algoritmus 
 \emph on
 iterativního lokálního dynamického programování 
@@ -10429,5 +10412,5 @@
  Nejdříve uveďme výsledky v porovnání s ostatními algoritmy pro jednoduchý
  systém.
- Dále bude zařazena diskuze negativních vlastností algoritmu, které mohli
+ Dále bude zařazena diskuze negativních vlastností algoritmu, které mohly
  vést k tomu, že se nepodařilo vytvořit funkční implementaci pro sychronní
  motor.
@@ -10449,6 +10432,6 @@
  Je založen na obecných principech, jmenovitě Hamilton-Jacobi-Bellmanova
  rovnost a Pontryaginův princip minima.
- Jedná se o iterační metodu, kdy vycházíme od jistého počátečního řízení
- a to v iteracích 
+ Jedná se o iterační metodu, tedy takovou, která vychází od jistého počátečního
+ řízení a to v iteracích 
 \begin_inset Quotes gld
 \end_inset
@@ -10469,5 +10452,5 @@
  trajektorie.
  Toto okolí je třeba zvolit při konkrétní implementaci algoritmu a jeho
- volba může mít nezanedbatelný vliv, na výsledky, které následně 
+ volba může mít nezanedbatelný vliv na výsledky, které následně 
 \emph on
 iLDP
@@ -10475,5 +10458,5 @@
  poskytne.
  Algoritmus pak odpovídá obecnému schématu dynamického programování, kde
- se v diskrétních časových okamžicích napočítávají od nejvýššího času zpět
+ se v diskrétních časových okamžicích napočítávají od nejvyššího času zpět
  optimální hodnoty Hamiltoniánů, které se postupně uchovávají v Bellmanově
  funkci.
@@ -10569,5 +10552,5 @@
 \end_inset
 
- je dosaženo nepřijatelné průměrné ztráty a pro ostatní vobly 
+ je dosaženo nepřijatelné průměrné ztráty a pro ostatní volby 
 \begin_inset Formula $P$
 \end_inset
@@ -10577,5 +10560,5 @@
 
 \begin_layout Standard
-Tedy ve srovnání s ostatními poskytuje 
+Tedy ve srovnání s ostatními algoritmy poskytuje 
 \emph on
 iLDP
@@ -10600,5 +10583,5 @@
 iLDP
 \emph default
- se objevily jisté komplikace a projevili se negativní vlastnosti tohoto
+ se objevily jisté komplikace a projevily se negativní vlastnosti tohoto
  algoritmu.
  Jedná se zejména o problematické chování při realizaci skutečné hodnoty
@@ -10623,5 +10606,5 @@
 \begin_layout Standard
 Nejprve se tedy zaměřme na obtíže týkající se jednoduchého systému.
- Jedním z důvodů, proč se systém vykazuje problematické chování pro 
+ Jedním z důvodů, proč systém vykazuje problematické chování pro 
 \begin_inset Formula $b$
 \end_inset
@@ -10664,6 +10647,6 @@
 
 , která je ovšem blízko u nuly.
- Další vlastností předpokládaného dobrého odhadu je, si jím budeme téměř
- jisti a tedy variance 
+ Další vlastností předpokládaného dobrého odhadu je, že si jím budeme téměř
+ jisti, a tedy variance 
 \begin_inset Formula $P$
 \end_inset
@@ -10699,5 +10682,5 @@
  musíme volit extrémně vysoké řídící zásahy, a to téměř blížící se nekonečnu.
  Na druhou stranu si je ale třeba uvědomit, že uvažovaná funkce regulátoru
- je pouze aproximací a tedy se dopouští jisté chyby.
+ je pouze aproximací, a tedy se dopouští jisté chyby.
  Tato chyba samozřejmě pak při velkém řídícím zásahu také narůstá.
  Dalším problémem je, že výpočty jsou prováděny na počítači, ten je při
@@ -10707,6 +10690,6 @@
 
 \begin_layout Standard
-Možností jak se vyhnout tomuto problému by bylo volit jiný tvar funkce regulátor
-u, otázkou by pak ale bylo jaký.
+Možností, jak se vyhnout tomuto problému, by bylo volit jiný tvar funkce
+ regulátoru, otázkou by pak ale bylo, jaký.
  Zvolený tvar regulátoru má totiž několik výhod.
  Za prvé koeficienty 
@@ -10714,5 +10697,5 @@
 \end_inset
 
- je možno určit metodou nejmenších čtverců a tedy jejich výpočet z množiny
+ je možno určit metodou nejmenších čtverců, a tedy jejich výpočet z množiny
  dvojic 
 \begin_inset Formula $\left\{ x^{(n)},u^{(n)}\right\} $
@@ -10725,5 +10708,5 @@
 \end_inset
 
- z rovnice jednoduchého systému, při požadavku dosažení požadované hodnoty
+ z rovnice jednoduchého systému při požadavku dosažení požadované hodnoty
  v jednom časovém kroku.
  Získaná funkce by pak měla relativně dobře aproximovat skutečné optimální
@@ -10756,5 +10739,5 @@
 
  záporné.
- Ovšem pro malé, téměř nulové, hodnoty parametru 
+ Ovšem pro malé, téměř nulové hodnoty parametru 
 \begin_inset Formula $b$
 \end_inset
@@ -10816,5 +10799,5 @@
 iLDP
 \emph default
- chyby, kterých se dopustíme její aproximací se následně přenášejí prakticky
+, chyby, kterých se dopustíme její aproximací, se následně přenášejí prakticky
  do všech ostatních částí algoritmu.
 \end_layout
@@ -10822,5 +10805,5 @@
 \begin_layout Standard
 Na druhou stranu se ale chyby v důsledku aproximace dopustíme velmi snadno.
- Bellmanova funkce může být totiž u složitějších systému značně komplikovaná
+ Bellmanova funkce může být totiž u složitějších systémů značně komplikovaná
  na to, aby ji bylo možno aproximovat lineární kombinací základních funkcí.
  Dalším problémem je pak počet těchto funkcí.
@@ -10847,6 +10830,6 @@
  funkcí, ale tato volba nemusí být vždy správná.
  Kdybychom si chtěli udělat představu o průběhu skutečné Bellmanovy funkce,
- abychom mohli snadněji určitě vhodnou aproximaci, narážíme na problém,
- že Bellmanovu funkci máme zadanou pomocí Hamilto-Jacobi-Bellmanovy rovnosti.
+ abychom mohli snadněji určit vhodnou aproximaci, narážíme na problém, že
+ Bellmanovu funkci máme zadanou pomocí Hamilto-Jacobi-Bellmanovy rovnosti.
 \end_layout
 
@@ -10880,5 +10863,5 @@
 
 .
- Vždy je uvedeno nejdříve prvotní očekávání a následně je komentováno, jestli
+ Vždy je uvedeno nejdříve prvotní očekávání a následně je komentováno, zda
  bylo potvrzeno:
 \end_layout
@@ -10932,5 +10915,5 @@
 
 \begin_layout Itemize
-pro složitější systém synchronního motoru, kde by bylo srovnání zřetelnější
+pro složitější systém synchronního motoru, kde by bylo srovnání zřetelnější,
  se nepodařilo implementovat funkční verzi iLDP algoritmu
 \end_layout
@@ -10985,5 +10968,5 @@
 ve srovnání s ostatními přístupy, které řeší danou úlohu vesměs analyticky
  a jsou založeny hlavně na maticových operacích, algoritmus iLDP používá
- aproximací, numerické minimalizace a výpočtů na vzorkových trajektoriích
+ aproximací, numerické minimalizace a výpočtů na vzorkových trajektoriích,
  a tedy výpočetní čas je řádově několikrát delší než pro ostatní metody
  (konkrétní příklad je výpočet 
@@ -10996,5 +10979,5 @@
 
  pro jednoduchý systém, který trval pro iLDP o tři řády déle než pro všechny
- ostatní algortimy) 
+ ostatní algoritmy) 
 \end_layout
 
@@ -11021,5 +11004,5 @@
  pro neomezenou a omezenou minimalizaci), dále numerická minimalizace hledá
  zpravidla jen lokální minima, je náročnější na výpočetní čas a je méně
- přesná a to zejména při výpočtech na aproximovaných funkcích, kde i malá
+ přesná, a to zejména při výpočtech na aproximovaných funkcích, kde i malá
  odchylka od správného průběhu původní funkce může dát špatný výsledek velmi
  vzdálený od správné hodnoty
@@ -11057,8 +11040,8 @@
 
 \begin_layout Itemize
-naopak je ale třeba vyřešit mnoho dílčích detailů, vytvořit aproximace funkcí
- i vhodnou reprezentaci okolí pro výpočet a samotná implementace se tedy
- může velmi zkomplikovat a dokonce se nemusí ani podařit snadno vytvořit
- funkční verzi algoritmu
+naopak je ale třeba vyřešit mnoho dílčích detailů, například vytvořit aproximace
+ funkcí a najít vhodnou reprezentaci okolí pro výpočet; samotná implementace
+ se tedy může velmi zkomplikovat a dokonce se nemusí ani podařit vytvoření
+ funkční verze algoritmu
 \end_layout
 
@@ -11070,6 +11053,6 @@
 \begin_deeper
 \begin_layout Itemize
-jak již bylo zmíněno iLDP hledá optimální řízení v okolí nějaké reprezentativní
- trajektorie a tedy zpravidla není zajištěna optimalita nalezeného řízení
+jak již bylo zmíněno, iLDP hledá optimální řízení v okolí nějaké reprezentativní
+ trajektorie, a tedy zpravidla není zajištěna optimalita nalezeného řízení
  v celém stavovém a řídícím prostoru
 \end_layout
@@ -11112,8 +11095,8 @@
 
  této práce je stručně popsána základní teorie duálního řízení a další teoretick
-é poznatky potřebné k popisu konkrétních algortimů pro nalezení optimálního
+é poznatky potřebné k popisu konkrétních algoritmů pro nalezení optimálního
  řízení.
- V další kapitole pak následuje přiblížení jednotlivých algoritmů použitých
- pro srovnání s ústředním algoritmem této práce 
+ V další kapitole následuje přiblížení jednotlivých algoritmů použitých
+ pro srovnání s ústředním algoritmem této práce: 
 \emph on
 iterativním lokálním dynamickým programováním
@@ -11147,5 +11130,5 @@
 \emph default
  pro složitější systém, synchronní motor s permanentními magnety, se nezdařila
- z důvodů obtíží při volbě aproximací.
+ z důvodu obtíží při volbě aproximací.
  Nepodařilo se nalézt takové aproximace zpětnovazebního řízení a Bellmanovy
  funkce, aby na jejich základě algoritmus 
@@ -11159,5 +11142,5 @@
 \emph default
 , který nalézá funkční řízení.
- Jedná se ale o neduální metodu a tedy s rostoucí neznalostí selhává.
+ Jedná se ale o neduální metodu, a tedy s rostoucí neznalostí selhává.
  Konkrétní popisy testovaných systémů a úpravy jejich rovnic pro potřeby
  jednotlivých algoritmů lze nalézt v kapitole 
@@ -11233,5 +11216,5 @@
  Pro jednoduchý systém bylo provedeno srovnání i s dalšími metodami návrhu
  řízení.
- Naopak pro složitější systém jsou k dispozici pouze výsleky získané pomocí
+ Naopak pro složitější systém jsou k dispozici pouze výsledky získané pomocí
  
 \emph on
@@ -11260,5 +11243,5 @@
 iLDP
 \emph default
- je třeba ještě zmínit problém týkající se volby aproximací, který se ukazuje
+, je třeba ještě zmínit problém týkající se volby aproximací, který se ukazuje
  být největší slabinou této metody.
 \end_layout